import bge

def doorOpenClose():
	
	""" This function checks the door states, plays the animations and sounds of the open and closing door based in the properties changed in the hinge object."""
	
	cont = bge.logic.getCurrentController()
	scene = bge.logic.getCurrentScene()
	own = cont.owner
	parent = own.parent
	
	# Actuators
	anim_open_close = cont.actuators["anim_open_close"] # Action actuator
	snd_open = cont.actuators["snd_open"] # Sound actuator
	snd_close = cont.actuators["snd_close"] # Sound actuator
	
	# Properties
	door_state = own["door_state"] # String property showing the door state, changed through property actuators
	
	# Variables
	action_frame = own.getActionFrame() # The actual animation frame of the hinge
	is_playing = own.isPlayingAction() # If the animation of the hinge is playing
	
	### INITIALIZE ###
	
	### ANIMATION ###
	
	### Close ###
	if door_state == "closed":
		
		# Initial state to frame 1.0
		if action_frame == 0.0 and is_playing == False:
			anim_open_close.frameStart, anim_open_close.frameEnd = 1.0, 1.0
			cont.activate(anim_open_close)
		
		# Normal close
		if action_frame == 15.0 and is_playing == False:
			anim_open_close.frameStart, anim_open_close.frameEnd = 14.0, 1.0
			cont.activate(anim_open_close)
		
		# Reverse close
		if action_frame == 45.0 and is_playing == False:
			anim_open_close.frameStart, anim_open_close.frameEnd = 44.0, 30.0
			cont.activate(anim_open_close)
	
	### Open ###
	# Open normal
	if door_state == "normal_open":
		
		if action_frame == 1.0 or action_frame == 30.0 and is_playing == False:
			
			anim_open_close.frameStart, anim_open_close.frameEnd = 1.0, 15.0
			cont.activate(anim_open_close)
	
	# Open reverse
	if door_state == "reverse_open":
		
		if action_frame == 1.0 or action_frame == 30.0 and is_playing == False:
			
			anim_open_close.frameStart, anim_open_close.frameEnd = 31.0, 45.0
			cont.activate(anim_open_close)
		
		
	### SOUND ###
	
	### Open ###
	if is_playing == True and door_state == "normal_open" or door_state == "reverse_open": # Checks if the animation is playing and the door state is open
		
		if action_frame > 1.0 and action_frame < 3.0 or action_frame > 31.0 and action_frame < 33.0: # Checks if the hinge animation is at the exact point for the sound
			
			snd_open.startSound()
	
	### Close ###
	if is_playing == True and door_state == "closed": # Checks if the animation is playing and the door state is closed
		
		if action_frame > 1.0 and action_frame < 3.0 or action_frame > 31.0 and action_frame < 33.0: # Checks if the hinge animation is at the exact point for the sound
			
			snd_close.startSound()




